String clazzTpl({package}) => """
import 'package:$package/store/main.dart';
import 'package:$package/debug/app_debug_model.dart';
import 'package:$package/store/flutter_redux/flutter_redux.dart';
import 'package:flutter/material.dart';
import 'package:redux/redux.dart';
import 'package:flutter/foundation.dart';

/// 请叫我code哥
/// Generates Dart code
class BaseStoreContainer extends StatelessWidget {
  final Function(Store<AppState>)? onInit;
  final Function(Store<AppState>)? onInitialBuild;
  final Function(Store<AppState>, Store<AppState>)? onWillChange;
  final Function(Store<AppState>)? onDidChange;
  final Function(Store<AppState>)? onDispose;
  final Widget? Function(BuildContext, Store<AppState>)? builder;
  final bool distinct;

  BaseStoreContainer({
    Key? key,
    this.onInit,
    this.onInitialBuild,
    this.onWillChange,
    this.onDidChange,
    this.onDispose,
    this.distinct = false,
    required this.builder,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return StoreConnector<AppState, Store<AppState>>(
      onInit: (store) {
        StaticStore.store = store;
        if (onInit != null) onInit!(store);
      },
      distinct: distinct,
      onWillChange: onWillChange,
      onDidChange: onDidChange,
      onInitialBuild: onInitialBuild,
      onDispose: onDispose,
      converter: (store) => store,
      builder: builder,
    );
  }
}

class StaticStore {
  static Store<AppState>? store;
}

extension BuildContextExtension on BuildContext {
  bool get isDev => StaticStore.store != null
      ? StaticStore.store!.state.userState!.findAppDebug(AppDebugKey.dev)
      : false;

  bool get isZh => Localizations.localeOf(this).languageCode.contains('zh');

  bool isOn(AppDebugKey key) => StaticStore.store != null
      ? StaticStore.store!.state.userState!.findAppDebug(key)
      : false;
}
""";
